=== debian/changelog ===
oiofs-fuse (20160411-1) wily; urgency=low

  * Initial release

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 11 Apr 2016 15:40:59 +0000
