=== debian/control ===
Source: oiofs-fuse
Section: unknown
Priority: optional
Maintainer: Romain Acciari <romain.acciari@openio.io>
Build-Depends: debhelper (>= 9), cmake, openio-sds, libprotobuf-dev (>= 3.0.0~b2), libprotoc-dev (>= 3.0.0~b2), libgrpc-dev (>= 0.11.1), libhiredis-dev, libfuse-dev, libglib2.0-dev, libgoogle-glog-dev, libgflags-dev, protobuf-compiler (>= 3.0.0~b2)
Standards-Version: 3.9.5
Homepage: http://gitlab.openio.io/openio/oio-fs
#Vcs-Git: git://anonscm.debian.org/collab-maint/oiofs-fuse.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/oiofs-fuse.git;a=summary

Package: oiofs-fuse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfuse2, libgrpc0 (>= 0.11.1), openio-sds, libgoogle-glog0v5
Description: OpenIO FileSystem FUSE adapter
 oiofs FUSE is a FUSE adapter that allows you to mount OpenIO SDS
 containers as filesystems on Linux systems.
 oiofs FUSE provides another means to access OpenIO SDS Storage.
